# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorlib: %global perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)}

# noarch, but to avoid debug* files interfering with manifest test:
%global debug_package %{nil}

# We need to patch the test suite if we have old versions of Test::More
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.88) ? 1 : 0);' 2>/dev/null || echo 0)

Name:		perl-PPIx-Regexp
Version:	0.026
Release:	1.%{__distinit}%{__distvers}
Summary:	Represent a regular expression of some sort
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/PPIx-Regexp/
Source0:	http://search.cpan.org/CPAN/authors/id/W/WY/WYANT/PPIx-Regexp-%{version}.tar.gz
Patch0:		PPIx-Regexp-0.026-old-Test::More.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# ----------------------------------------------------------------------------
# Module build requirements
# ----------------------------------------------------------------------------
BuildRequires:	perl(ExtUtils::MakeMaker)
# ----------------------------------------------------------------------------
# Module requirements
# ----------------------------------------------------------------------------
BuildRequires:	perl(List::MoreUtils)
BuildRequires:	perl(PPI::Document) >= 1.117
BuildRequires:	perl(Scalar::Util) >= 1.10
BuildRequires:	perl(Task::Weaken)
# ----------------------------------------------------------------------------
# Regular test suite requirements
# ----------------------------------------------------------------------------
BuildRequires:	perl(Test::More) >= 0.4
# ----------------------------------------------------------------------------
# Release test requirements (spelling check intentionally skipped)
# ----------------------------------------------------------------------------
BuildRequires:	perl(ExtUtils::Manifest)
# Test::CPAN::Changes only available if we have Perl 5.10.0 onwards
%if %(perl -e 'print $] >= 5.010000 ? 1 : 0;')
BuildRequires:	perl(Test::CPAN::Changes)
%endif
BuildRequires:	perl(Test::Kwalitee)
# Test::Perl::Critic only available if we have Perl 5.8.8 onwards
# Test::Perl::Critic -> Perl::Critic -> PPIx::Regexp
%if %(perl -e 'print $] >= 5.008008 ? 1 : 0;') && 0%{!?perl_bootstrap:1}
BuildRequires:	perl(Test::Perl::Critic)
%endif
BuildRequires:	perl(Test::Pod) >= 1.0
BuildRequires:	perl(Test::Pod::Coverage) >= 1.0
# ----------------------------------------------------------------------------
# Runtime requirements not automatically picked up by RPM
# ----------------------------------------------------------------------------
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(PPI::Document) >= 1.117
Requires:	perl(Task::Weaken)

%description
The purpose of the PPIx-Regexp package is to parse regular expressions in a
manner similar to the way the PPI package parses Perl. This class forms the
root of the parse tree, playing a role similar to PPI::Document.

%prep
%setup -q -n PPIx-Regexp-%{version}

# Work with Test::More < 0.88
%if %{old_test_more}
%patch0 -p1
%endif

# Make sure we don't get bogus docfile dependencies
chmod -x eg/*
sed -i '1 s|/usr/local/bin/perl|/usr/bin/perl|' eg/*

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install PERL_INSTALL_ROOT=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} \;
find %{buildroot} -depth -type d -exec rmdir {} \; 2>/dev/null
%{_fixperms} %{buildroot}

%check
make test
make test TEST_FILES="$(echo $(find xt/ -name '*.t'))"

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes eg/ LICENSES/ README
%{perl_vendorlib}/PPIx/
%{_mandir}/man3/PPIx::Regexp*.3pm*

%changelog
* Sat Feb 25 2012 Paul Howarth <paul@city-fan.org> - 0.026-1
- Update to 0.026
  - Add support for \F (fold case), added in 5.15.8
- Update patch for building with Test::More < 0.88

* Wed Feb  8 2012 Paul Howarth <paul@city-fan.org> - 0.025-2
- Don't BR: perl(Test::Perl::Critic) if we're bootstrapping

* Thu Jan  5 2012 Paul Howarth <paul@city-fan.org> - 0.025-1
- Update to 0.025
  - Tolerate leading and trailing white space around the regular expression;
    these are still round-trip safe, since the white space is tokenized
  - Make Changes file conform to CPAN::Changes, and add xt/author/changes.t
    to ensure continued compliance
- BR: perl(Test::CPAN::Changes)
- Update patch for building with Test::More < 0.88

* Mon Dec 19 2011 Paul Howarth <paul@city-fan.org> - 0.024-1
- Update to 0.024
  - Reinstate author test xt/author/manifest.t, which was clobbered shortly
    before the release of 0.021_10
- Explicitly disable debuginfo package to avoid interfering with manifest test
- Update patch for building with Test::More < 0.88

* Thu Dec  8 2011 Paul Howarth <paul@city-fan.org> - 0.023-1
- Update to 0.023
  - Correct address of FSF in the version of the GPL distributed in
    LICENSES/Copying
- Update patch for building with old Test::More versions

* Fri Nov 25 2011 Paul Howarth <paul@city-fan.org> - 0.022-1
- Update to 0.022
  - Support for default modifiers, including:
    - default_modifiers argument to new() in PPIx::Regexp,
      PPIx::Regexp::Tokenizer, and PPIx::Regexp::Dumper
    - Public method modifier_asserted() on PPIx::Regexp, to return
      whether a given modifier is actually in effect
  - Don't initialize effective modifiers with '^', since that wrongly
    asserts that /d has been seen somewhere along the line
  - Implement negation of match-semantic modifiers (e.g. 'no re /u;') by
    setting the relevant datum to undef
  - Fix PPIx::Regexp::Token::Whitespace->can_be_quantified() to return
    false
  - Require Test::More 0.88 for installation
  - Have Makefile.PL make use of {BUILD_REQUIRES} if it is available
  - Correct various documentation errors
- Patch test suite to work with Test::More < 0.88 if necessary
- Run author tests (except the spelling check, which has surprising failures)
- Add buildreqs for author tests:
  - perl(ExtUtils::Manifest)
  - perl(Test::Kwalitee)
  - perl(Test::Perl::Critic)
  - perl(Test::Pod) ≥ 1.0
  - perl(Test::Pod::Coverage) ≥ 1.0

* Sat Jul 23 2011 Paul Howarth <paul@city-fan.org> - 0.021-2
- Rebuild for perl 5.14.1 in Rawhide

* Sat Jul 23 2011 Paul Howarth <paul@city-fan.org> - 0.021-1
- Update to 0.021
  - Modified tokenizer to correctly handle a back slash used as a delimiter
  - PPIx::Regexp::Dumper now dumps the results of ppi() if that method is
    present and -verbose is asserted
- Fix dist tag for CentOS 6 and Scientific Linux

* Mon Apr  4 2011 Paul Howarth <paul@city-fan.org> - 0.020-1
- Update to 0.020
  - Corrected perl_version_introduced(): \R is now 5.009005 (was 5.000)
- Move module back to vendor directories rather than perl directories
- Nobody else likes macros for commands

* Wed Mar  2 2011 Paul Howarth <paul@city-fan.org> - 0.019-1
- Update to 0.019
  - Various corrections to perl_version_introduced():
    - \X is now 5.006 (was 5.000)
    - \N{name} is now 5.006001 (was 5.006)
    - \N{U+xxxx} is now 5.008 (was 5.006)
  - The \C is now parsed as a PPIx::Regexp::Token::CharClass::Simple
  - Ensure that \N{$foo} parses as a Unicode literal, not a quantified \N;
    the ordinal() method returns undef for this.
  - Understand the /aa modifier, introduced with 5.13.10
  - Report perl_version_introduced() of 5.013010 for the new semantic
    modifiers when modifying the entire expression
  - Correct handling of interpolations like ${^foo} and $#{foo}

* Thu Feb 17 2011 Paul Howarth <paul@city-fan.org> - 0.018-1
- Update to 0.018
  - Take account of possible '$' or '@' casts before a symbol in an
    interpolation (e.g. $$foo{bar}, which is equivalent to $foo->{bar})
  - Override ppi() in PPIx::Regexp::Token::Interpolation to provide the
    proper PPI when variable names are bracketed
  - Properly parse bracketed variable names, which may not be subscripted

* Thu Jan 27 2011 Paul Howarth <paul@city-fan.org> - 0.017-1
- Update to 0.017
  - Add the /a modifier to PPI::Regexp::Token::Modifiers, legal only in the
    (?:...) construction
  - When parsing an interpolation from a replacement string (rather than a
    regular expression), take subscripts at face value rather than trying to
    disambiguate them from quantifiers and character classes, which they can't
    be in this context
- Install to perl dirs rather than vendor dirs

* Thu Jan  6 2011 Paul Howarth <paul@city-fan.org> - 0.016-1
- Update to 0.016
  - The PPIx::Regexp::Token::Code perl_version_introduced() method now returns
    the minimum Perl version (currently set to 5.000) if it is used to
    represent the substitution portion of s///e

* Wed Dec 15 2010 Paul Howarth <paul@city-fan.org> - 0.015-2
- Import from Fedora

* Wed Oct 27 2010 Petr Pisar <ppisar@redhat.com> - 0.015-1
- 0.015 bump

* Mon Oct 18 2010 Petr Pisar <ppisar@redhat.com> - 0.014-1
- 0.014 bump

* Mon Oct 04 2010 Petr Pisar <ppisar@redhat.com> - 0.012-1
- 0.012 bump

* Wed Sep 22 2010 Petr Pisar <ppisar@redhat.com> - 0.011-1
- 0.011 bump
- Remove unversioned Requires

* Thu Sep 16 2010 Petr Pisar <ppisar@redhat.com> - 0.010-1
- 0.010 bump

* Tue Jun  8 2010 Petr Pisar <ppisar@redhat.com> - 0.007-1
- Specfile autogenerated by cpanspec 1.78 (bug #598553)
